<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [generateContribution](#generatecontribution)
-   [addContributionShares](#addcontributionshares)
-   [verifyContributionShare](#verifycontributionshare)
-   [addVerificationVectors](#addverificationvectors)

## generateContribution

[index.js:10-41](https://github.com/wanderer/dkg/blob/1f82d1133c4dd11b5de8fa00ccd527ea23eaf901/index.js#L10-L41 "Source code on GitHub")

generates a members contribution to the DKG

**Parameters**

-   `bls` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** an instance of [bls-lib](https://github.com/wanderer/bls-lib)
-   `ids` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)>** an array of pointers containing the ids of the members of the groups
-   `threshold` **[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** the threshold number of members needed to sign on a message to
    produce the groups signature

Returns **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** the object contains `verificationVector` which is an array of public key pointers
and `secretKeyContribution` which is an array of secret key pointers

## addContributionShares

[index.js:49-56](https://github.com/wanderer/dkg/blob/1f82d1133c4dd11b5de8fa00ccd527ea23eaf901/index.js#L49-L56 "Source code on GitHub")

Adds secret key contribution together to produce a single secret key

**Parameters**

-   `bls` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** an instance of [bls-lib](https://github.com/wanderer/bls-lib)
-   `secretKeyShares` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)>** an array of pointer to secret keys to add

Returns **[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** a pointer to the resulting secret key

## verifyContributionShare

[index.js:67-80](https://github.com/wanderer/dkg/blob/1f82d1133c4dd11b5de8fa00ccd527ea23eaf901/index.js#L67-L80 "Source code on GitHub")

Verifies a contribution share

**Parameters**

-   `bls` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** an instance of [bls-lib](https://github.com/wanderer/bls-lib)
-   `id` **[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** a pointer to the id of the member verifiing the contribution
-   `contribution` **[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** a pointer to the secret key contribution
-   `vvec` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)>** an array of pointers to public keys which is
    the verification vector of the sender of the contribution

Returns **[Boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** 

## addVerificationVectors

[index.js:87-101](https://github.com/wanderer/dkg/blob/1f82d1133c4dd11b5de8fa00ccd527ea23eaf901/index.js#L87-L101 "Source code on GitHub")

Adds an array of verification vectors together to produce the groups verification vector

**Parameters**

-   `bls` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** an instance of [bls-lib](https://github.com/wanderer/bls-lib)
-   `vvecs` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)>>** an array containing all the groups verifciation vectors
